if(isFile("Add-Ons/System_ReturnToBlockland/server.cs") && $AddOn__Server_TrustLevels == 1)
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Brick Namer","Trust Levels","TrustLevel::NameGun","list NONE 0 Build 1 Full 2","Tool_BricknameGun",2,0,1);
}
else
	$TrustLevel::NameGun = 2;

datablock ParticleData(nameGunParticle : printGunParticle)
{
	colors[0] = "0.8 0.1 0.12 0.466667";
	colors[1] = "0.8 0.1 0.12 0";
	sizes[0] = 1.49545;
	sizes[1] = 0.195424;
	times[0] = 0;
	times[1] = 1;
	times[2] = 2;
	times[3] = 2;
};

datablock ParticleEmitterData(nameGunEmitter : printGunEmitter)
{
	particles = "nameGunParticle";
};

datablock ItemData(nameGun : printGun)
{
	colorShiftColor = "0.8 0.1 0.12 1";
	UIName = "Brick Namer";
	image = "nameGunImage";
};

datablock ShapeBaseImageData(nameGunImage : printGunImage)
{
	colorShiftColor = nameGun.colorShiftColor;
	stateEmitter[2] = nameGunEmitter;
};

function nameGunImage::onFire(%this,%obj,%slot)
{
	printGunImage::onFire(%this,%obj,%slot);
}

function nameGunImage::onHitObject(%this, %obj, %slot, %col, %pos, %norm)
{
	if(%col.getclassname() !$= "fxDTSBrick")
		return;
	if(gettrustlevel(%obj,%col) >= $TrustLevel::NameGun)
	{
		if(%obj.client.BrickName $= "")
			%col.setname("");
		else
		{
			if(%obj.client.IncName == 1)
			{
				%obj.client.IncName[%obj.client.BrickName]++;
				%col.setNTObjectName(%obj.client.BrickName @ %obj.client.IncName[%obj.client.BrickName]);
			}
			else
				%col.setNTObjectName(%obj.client.BrickName);
		}
	}
	else
		centerprint(%obj.client, "\c0" @ %col.getGroup().name @ " does not trust you enough to do that.", 2, 2);
}

function nameGunImage::onMount(%this,%obj,%slot)
{
	if(%obj.client.hasmounted[nameGun] == 0)
	{
		messageclient(%client,'',"<color:00ff00>/useNameGun - Equips the brick namer.");
		messageclient(%obj.client,'',"<color:00ff00>/Brickname [name] - Sets the name that NameGun will put on bricks. Leave blank to remove name.");
		messageclient(%obj.client,'',"<color:00ff00>/IncName [1/0] - Toggles Number Increment, this will add a number to the end of your brickname, and increase by 1 every time you set a name. 1 = on, 0 = off.");
		messageclient(%obj.client,'',"<color:00ff00>/ResetInc [name] - Sets the increment number for the name back to 0.");
		%obj.client.hasmounted[namegun] = 1;
	}
}

function serverCmdBrickName(%client,%string)
{
	if(%string $= "")
	{
		%client.BrickName = "";
		messageclient(%client,'',"Brick namer will now turn names blank.");
	}
	else
	{
		%client.BrickName = %string;
		messageclient(%client,'','Brick namer set to <color:00ff00>%1<color:ff0000>.',%string);
	}
}

function serverCmdNameGun(%client)
{
	%player = %client.player;
	if(isObject(%player))
	{
		%player.updateArm(nameGunImage);
		%player.mountImage(nameGunImage,0);	
	}
}

package namegunhelp
{
	function serverCmdHelp(%client,%arg1,%arg2,%arg3)
	{
		messageclient(%client,'',"<color:00ff00>/useNameGun - Equips the brick namer.");
		messageclient(%client,'',"<color:00ff00>/Brickname [name] - Sets the name that brick namer will put on bricks. Leave blank to remove name.");
		messageclient(%client,'',"<color:00ff00>/IncName Bool - Toggles Number Increment, this will add a number to the end of your brickname, and increase by 1 every time you set a name. 1 = on, 0 = off.");
		messageclient(%obj.client,'',"<color:00ff00>/ResetInc [name] - Sets the increment number for the name back to 0.");
		Parent::serverCmdHelp(%client,%arg1,%arg2,%arg3);
	}
};
activatepackage(namegunhelp);

function serverCmdIncName(%client,%val)
{
	%client.IncName = %val ? true:false;
}

function serverCmdResetInc(%client,%name)
{
	%client.IncName[%name] = 0;
}